<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
        PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.yiqi.core.mapper.ClothHangerMapper">

    <resultMap type="ClothHanger" id="ClothHangerResult">
        <result property="id" column="id"/>
        <result property="orgId" column="org_id"/>
        <result property="sourceType" column="source_type"/>
        <result property="name" column="name"/>
        <result property="firstNum" column="first_num"/>
        <result property="endNum" column="end_num"/>
        <result property="isLongHanger" column="is_long_hanger"/>
        <result property="status" column="status"/>
        <result property="delFlag" column="del_flag"/>
        <result property="createById" column="create_by_id"/>
        <result property="createBy" column="create_by"/>
        <result property="createTime" column="create_time"/>
        <result property="updateById" column="update_by_id"/>
        <result property="updateBy" column="update_by"/>
        <result property="updateTime" column="update_time"/>
        <result property="remark" column="remark"/>
    </resultMap>

    <sql id="selectClothHangerVo">
        select id, org_id, source_type, name, first_num, end_num, is_long_hanger, status, del_flag, create_by_id, create_by, create_time, update_by_id, update_by, update_time, remark
        from cloth_hanger
    </sql>

    <select id="selectClothHangerList" resultType="com.yiqi.core.domain.vo.ClothHangerVO">
        select a.id as id , a.source_type as sourceType, a.name as name, a.first_num as firstNum,
               a.end_num as endNum, a.is_long_hanger as isLongHanger, a.status as status, a.del_flag as delFlag,

                s.name as storeName,

                f.factory_name as factoryName
                from cloth_hanger a
                left join sys_store s on a.org_id = s.id
                left join manage_factory f on a.org_id = f.id
        <where>
            and a.del_flag='0'
            <if test="factoryName != null ">
                and f.factory_name = #{factoryName}
            </if>
            <if test="storeName != null ">
                and s.name = #{storeName}
            </if>
            <if test="name != null  and name != ''">
                and a.name like concat('%', #{name}, '%')
            </if>
            <if test="sourceType != null  and sourceType != '00'">
                and a.source_type = #{sourceType}
            </if>
            <if test="sourceType != null  and sourceType != '00'">
                and a.org_id = #{orgId}
            </if>
        </where>
    </select>

    <select id="selectClothHangerById" parameterType="Long"
            resultMap="ClothHangerResult">
        <include refid="selectClothHangerVo"/>
        where id = #{id}
        and del_flag='0'
    </select>

    <insert id="insertClothHanger" parameterType="ClothHanger" useGeneratedKeys="true"
            keyProperty="id">
        insert into cloth_hanger
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="orgId != null">org_id,
            </if>
            <if test="sourceType != null">source_type,
            </if>
            <if test="name != null"> name,
            </if>
            <if test="firstNum != null">first_num,
            </if>
            <if test="endNum != null">end_num,
            </if>
            <if test="isLongHanger != null">is_long_hanger,
            </if>
            <if test="status != null">status,
            </if>
            <if test="delFlag != null">del_flag,
            </if>
            <if test="createById != null">create_by_id,
            </if>
            <if test="createBy != null">create_by,
            </if>
            <if test="createTime != null">create_time,
            </if>
            <if test="updateById != null">update_by_id,
            </if>
            <if test="updateBy != null">update_by,
            </if>
            <if test="updateTime != null">update_time,
            </if>
            <if test="remark != null">remark,
            </if>
        </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="orgId != null">#{orgId},
            </if>
            <if test="sourceType != null">#{sourceType},
            </if>
            <if test="name != null">#{name},
            </if>
            <if test="firstNum != null">#{firstNum},
            </if>
            <if test="endNum != null">#{endNum},
            </if>
            <if test="isLongHanger != null">#{isLongHanger},
            </if>
            <if test="status != null">#{status},
            </if>
            <if test="delFlag != null">#{delFlag},
            </if>
            <if test="createById != null">#{createById},
            </if>
            <if test="createBy != null">#{createBy},
            </if>
            <if test="createTime != null">#{createTime},
            </if>
            <if test="updateById != null">#{updateById},
            </if>
            <if test="updateBy != null">#{updateBy},
            </if>
            <if test="updateTime != null">#{updateTime},
            </if>
            <if test="remark != null">#{remark},
            </if>
        </trim>
    </insert>

    <update id="updateClothHanger" parameterType="ClothHanger">
        update cloth_hanger
        <trim prefix="SET" suffixOverrides=",">
            <if test="orgId != null">org_id =
                #{orgId},
            </if>
            <if test="sourceType != null">source_type =
                #{sourceType},
            </if>
            <if test="name != null">name =
                #{name},
            </if>
            <if test="firstNum != null">first_num =
                #{firstNum},
            </if>
            <if test="endNum != null">end_num =
                #{endNum},
            </if>
            <if test="isLongHanger != null">is_long_hanger =
                #{isLongHanger},
            </if>
            <if test="status != null">status =
                #{status},
            </if>
            <if test="delFlag != null">del_flag =
                #{delFlag},
            </if>
            <if test="createById != null">create_by_id =
                #{createById},
            </if>
            <if test="createBy != null">create_by =
                #{createBy},
            </if>
            <if test="createTime != null">create_time =
                #{createTime},
            </if>
            <if test="updateById != null">update_by_id =
                #{updateById},
            </if>
            <if test="updateBy != null">update_by =
                #{updateBy},
            </if>
            <if test="updateTime != null">update_time =
                #{updateTime},
            </if>
            <if test="remark != null">remark =
                #{remark},
            </if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deleteClothHangerById" parameterType="Long">
        update cloth_hanger set del_flag='2' where id = #{id}
    </delete>

    <delete id="deleteClothHangerByIds" parameterType="String">
        update cloth_hanger set del_flag='2' where id in
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>



</mapper>